From: mhiramat at kernel.org (Masami Hiramatsu)
Subject: [PATCH v5 02/19] selftests: ftrace: Add probe event argument syntax testcase
Date: Thu, 8 Mar 2018 17:44:34 +0900 [thread overview]
Message-ID: <152049867449.7289.11414429946367300873.stgit@devbox> (raw)
In-Reply-To: <152049860385.7289.14079393589900496424.stgit@devbox>
Add a testcase for probe event argument syntax which
ensures the kprobe_events interface correctly parses
given event arguments.
Signed-off-by: Masami Hiramatsu <mhiramat at kernel.org>
---
.../ftrace/test.d/kprobe/kprobe_args_syntax.tc | 97 ++++++++++++++++++++
1 file changed, 97 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc
diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc
new file mode 100644
index 000000000000..231bcd2c4eb5
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc
@@ -0,0 +1,97 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: Kprobe event argument syntax
+
+[ -f kprobe_events ] || exit_unsupported # this is configurable
+
+grep "x8/16/32/64" README > /dev/null || exit_unsupported # version issue
+
+echo 0 > events/enable
+echo > kprobe_events
+
+PROBEFUNC="vfs_read"
+GOODREG=
+BADREG=
+GOODSYM="_sdata"
+if ! grep -qw ${GOODSYM} /proc/kallsyms ; then
+ GOODSYM=$PROBEFUNC
+fi
+BADSYM="deaqswdefr"
+SYMADDR=0x`grep -w ${GOODSYM} /proc/kallsyms | cut -f 1 -d " "`
+GOODTYPE="x16"
+BADTYPE="y16"
+
+case `uname -m` in
+x86_64|i[3456]86)
+ GOODREG=%ax
+ BADREG=%ex
+;;
+aarch64)
+ GOODREG=%x0
+ BADREG=%ax
+;;
+arm*)
+ GOODREG=%r0
+ BADREG=%ax
+;;
+esac
+
+test_goodarg() # Good-args
+{
+ while [ "$1" ]; do
+ echo "p ${PROBEFUNC} $1" > kprobe_events
+ shift 1
+ done;
+}
+
+test_badarg() # Bad-args
+{
+ while [ "$1" ]; do
+ ! echo "p ${PROBEFUNC} $1" > kprobe_events
+ shift 1
+ done;
+}
+
+echo > kprobe_events
+
+: "Register access"
+test_goodarg ${GOODREG}
+test_badarg ${BADREG}
+
+: "Symbol access"
+test_goodarg "@${GOODSYM}" "@${SYMADDR}" "@${GOODSYM}+10" "@${GOODSYM}-10"
+test_badarg "@" "@${BADSYM}" "@${GOODSYM}*10" "@${GOODSYM}/10" \
+ "@${GOODSYM}%10" "@${GOODSYM}&10" "@${GOODSYM}|10"
+
+: "Stack access"
+test_goodarg "\$stack" "\$stack0" "\$stack1"
+test_badarg "\$stackp" "\$stack0+10" "\$stack1-10"
+
+: "Retval access"
+echo "r ${PROBEFUNC} \$retval" > kprobe_events
+! echo "p ${PROBEFUNC} \$retval" > kprobe_events
+
+: "Comm access"
+test_goodarg "\$comm"
+
+: "Indirect memory access"
+test_goodarg "+0(${GOODREG})" "-0(${GOODREG})" "+10(\$stack)" \
+ "+0(\$stack1)" "+10(@${GOODSYM}-10)" "+0(+10(+20(\$stack)))"
+test_badarg "+(${GOODREG})" "(${GOODREG}+10)" "-(${GOODREG})" "(${GOODREG})" \
+ "+10(\$comm)" "+0(${GOODREG})+10"
+
+: "Name assignment"
+test_goodarg "varname=${GOODREG}"
+test_badarg "varname=varname2=${GOODREG}"
+
+: "Type syntax"
+test_goodarg "${GOODREG}:${GOODTYPE}"
+test_badarg "${GOODREG}::${GOODTYPE}" "${GOODREG}:${BADTYPE}" \
+ "${GOODTYPE}:${GOODREG}"
+
+: "Combination check"
+
+test_goodarg "\$comm:string" "+0(\$stack):string"
+test_badarg "\$comm:x64" "\$stack:string" "${GOODREG}:string"
+
+echo > kprobe_events
--
To unsubscribe from this list: send the line "unsubscribe linux-kselftest" in
the body of a message to majordomo at vger.kernel.org
More majordomo info at http://vger.kernel.org/majordomo-info.html
WARNING: multiple messages have this Message-ID (diff)
From: mhiramat@kernel.org (Masami Hiramatsu)
Subject: [PATCH v5 02/19] selftests: ftrace: Add probe event argument syntax testcase
Date: Thu, 8 Mar 2018 17:44:34 +0900 [thread overview]
Message-ID: <152049867449.7289.11414429946367300873.stgit@devbox> (raw)
Message-ID: <20180308084434.d2wX1dAfuIxd7zTipT2VC2l0qddVSLPy3NrWN1ucs5s@z> (raw)
In-Reply-To: <152049860385.7289.14079393589900496424.stgit@devbox>
Add a testcase for probe event argument syntax which
ensures the kprobe_events interface correctly parses
given event arguments.
Signed-off-by: Masami Hiramatsu <mhiramat at kernel.org>
---
.../ftrace/test.d/kprobe/kprobe_args_syntax.tc | 97 ++++++++++++++++++++
1 file changed, 97 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc
diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc
new file mode 100644
index 000000000000..231bcd2c4eb5
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_syntax.tc
@@ -0,0 +1,97 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: Kprobe event argument syntax
+
+[ -f kprobe_events ] || exit_unsupported # this is configurable
+
+grep "x8/16/32/64" README > /dev/null || exit_unsupported # version issue
+
+echo 0 > events/enable
+echo > kprobe_events
+
+PROBEFUNC="vfs_read"
+GOODREG=
+BADREG=
+GOODSYM="_sdata"
+if ! grep -qw ${GOODSYM} /proc/kallsyms ; then
+ GOODSYM=$PROBEFUNC
+fi
+BADSYM="deaqswdefr"
+SYMADDR=0x`grep -w ${GOODSYM} /proc/kallsyms | cut -f 1 -d " "`
+GOODTYPE="x16"
+BADTYPE="y16"
+
+case `uname -m` in
+x86_64|i[3456]86)
+ GOODREG=%ax
+ BADREG=%ex
+;;
+aarch64)
+ GOODREG=%x0
+ BADREG=%ax
+;;
+arm*)
+ GOODREG=%r0
+ BADREG=%ax
+;;
+esac
+
+test_goodarg() # Good-args
+{
+ while [ "$1" ]; do
+ echo "p ${PROBEFUNC} $1" > kprobe_events
+ shift 1
+ done;
+}
+
+test_badarg() # Bad-args
+{
+ while [ "$1" ]; do
+ ! echo "p ${PROBEFUNC} $1" > kprobe_events
+ shift 1
+ done;
+}
+
+echo > kprobe_events
+
+: "Register access"
+test_goodarg ${GOODREG}
+test_badarg ${BADREG}
+
+: "Symbol access"
+test_goodarg "@${GOODSYM}" "@${SYMADDR}" "@${GOODSYM}+10" "@${GOODSYM}-10"
+test_badarg "@" "@${BADSYM}" "@${GOODSYM}*10" "@${GOODSYM}/10" \
+ "@${GOODSYM}%10" "@${GOODSYM}&10" "@${GOODSYM}|10"
+
+: "Stack access"
+test_goodarg "\$stack" "\$stack0" "\$stack1"
+test_badarg "\$stackp" "\$stack0+10" "\$stack1-10"
+
+: "Retval access"
+echo "r ${PROBEFUNC} \$retval" > kprobe_events
+! echo "p ${PROBEFUNC} \$retval" > kprobe_events
+
+: "Comm access"
+test_goodarg "\$comm"
+
+: "Indirect memory access"
+test_goodarg "+0(${GOODREG})" "-0(${GOODREG})" "+10(\$stack)" \
+ "+0(\$stack1)" "+10(@${GOODSYM}-10)" "+0(+10(+20(\$stack)))"
+test_badarg "+(${GOODREG})" "(${GOODREG}+10)" "-(${GOODREG})" "(${GOODREG})" \
+ "+10(\$comm)" "+0(${GOODREG})+10"
+
+: "Name assignment"
+test_goodarg "varname=${GOODREG}"
+test_badarg "varname=varname2=${GOODREG}"
+
+: "Type syntax"
+test_goodarg "${GOODREG}:${GOODTYPE}"
+test_badarg "${GOODREG}::${GOODTYPE}" "${GOODREG}:${BADTYPE}" \
+ "${GOODTYPE}:${GOODREG}"
+
+: "Combination check"
+
+test_goodarg "\$comm:string" "+0(\$stack):string"
+test_badarg "\$comm:x64" "\$stack:string" "${GOODREG}:string"
+
+echo > kprobe_events
--
To unsubscribe from this list: send the line "unsubscribe linux-kselftest" in
the body of a message to majordomo at vger.kernel.org
More majordomo info at http://vger.kernel.org/majordomo-info.html
next prev parent reply other threads:[~2018-03-08 8:44 UTC|newest]
Thread overview: 50+ messages / expand[flat|nested] mbox.gz Atom feed top
2018-03-08 8:43 [PATCH v5 00/19] tracing: probeevent: Improve fetcharg features mhiramat
2018-03-08 8:43 ` Masami Hiramatsu
2018-03-08 8:44 ` [PATCH v5 01/19] [BUGFIX] tracing: probeevent: Fix to support minus offset from symbol mhiramat
2018-03-08 8:44 ` Masami Hiramatsu
2018-03-08 8:44 ` mhiramat [this message]
2018-03-08 8:44 ` [PATCH v5 02/19] selftests: ftrace: Add probe event argument syntax testcase Masami Hiramatsu
2018-03-08 8:45 ` [PATCH v5 03/19] selftests: ftrace: Add a testcase for string type with kprobe_event mhiramat
2018-03-08 8:45 ` Masami Hiramatsu
2018-03-08 8:45 ` [PATCH v5 04/19] selftests: ftrace: Add a testcase for probepoint mhiramat
2018-03-08 8:45 ` Masami Hiramatsu
2018-03-08 8:46 ` [PATCH v5 05/19] tracing: probeevent: Cleanup print argument functions mhiramat
2018-03-08 8:46 ` Masami Hiramatsu
2018-03-08 8:46 ` [PATCH v5 06/19] tracing: probeevent: Cleanup argument field definition mhiramat
2018-03-08 8:46 ` Masami Hiramatsu
2018-03-08 8:46 ` [PATCH v5 07/19] tracing: probeevent: Remove NOKPROBE_SYMBOL from print functions mhiramat
2018-03-08 8:46 ` Masami Hiramatsu
2018-03-08 8:47 ` [PATCH v5 08/19] tracing: probeevent: Introduce new argument fetching code mhiramat
2018-03-08 8:47 ` Masami Hiramatsu
2018-03-08 8:47 ` [PATCH v5 09/19] tracing: probeevent: Unify fetch type tables mhiramat
2018-03-08 8:47 ` Masami Hiramatsu
2018-03-08 8:47 ` [PATCH v5 10/19] tracing: probeevent: Return consumed bytes of dynamic area mhiramat
2018-03-08 8:47 ` Masami Hiramatsu
2018-03-08 8:48 ` [PATCH v5 11/19] tracing: probeevent: Append traceprobe_ for exported function mhiramat
2018-03-08 8:48 ` Masami Hiramatsu
2018-03-08 8:48 ` [PATCH v5 12/19] tracing: probeevent: Unify fetch_insn processing common part mhiramat
2018-03-08 8:48 ` Masami Hiramatsu
2018-03-08 8:49 ` [PATCH v5 13/19] tracing: probeevent: Add symbol type mhiramat
2018-03-08 8:49 ` Masami Hiramatsu
2018-03-08 8:49 ` [PATCH v5 14/19] x86: ptrace: Add function argument access API mhiramat
2018-03-08 8:49 ` Masami Hiramatsu
2018-03-08 8:50 ` [PATCH v5 15/19] tracing: probeevent: Add $argN for accessing function args mhiramat
2018-03-08 8:50 ` Masami Hiramatsu
2018-03-08 8:50 ` [PATCH v5 16/19] tracing: probeevent: Add array type support mhiramat
2018-03-08 8:50 ` Masami Hiramatsu
2018-03-15 5:48 ` ravi.bangoria
2018-03-15 5:48 ` Ravi Bangoria
2018-03-15 7:18 ` mhiramat
2018-03-15 7:18 ` Masami Hiramatsu
2018-03-15 7:23 ` mhiramat
2018-03-15 7:23 ` Masami Hiramatsu
2018-03-15 8:01 ` ravi.bangoria
2018-03-15 8:01 ` Ravi Bangoria
2018-03-16 14:48 ` mhiramat
2018-03-16 14:48 ` Masami Hiramatsu
2018-03-08 8:51 ` [PATCH v5 17/19] selftests: ftrace: Add a testcase for symbol type mhiramat
2018-03-08 8:51 ` Masami Hiramatsu
2018-03-08 8:51 ` [PATCH v5 18/19] selftests: ftrace: Add a testcase for $argN with kprobe_event mhiramat
2018-03-08 8:51 ` Masami Hiramatsu
2018-03-08 8:52 ` [PATCH v5 19/19] selftests: ftrace: Add a testcase for array type " mhiramat
2018-03-08 8:52 ` Masami Hiramatsu
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=152049867449.7289.11414429946367300873.stgit@devbox \
--to=linux-kselftest@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox